--- JoglPipelineOLD.java	2016-11-07 16:27:54.000000000 +0100
+++ JoglPipeline.java	2017-12-28 22:54:49.000000000 +0100
@@ -2809,270 +3376,311 @@
 
     }
 
+
     // ---------------------------------------------------------------------
 
     //
-    // GLSLShaderProgramRetained methods
+    // ModelClipRetained methods
     //
 
-    // ShaderAttributeValue methods
-
     @Override
     ShaderError setGLSLUniform1i(Context ctx,
-            ShaderProgramId shaderProgramId,
-            ShaderAttrLoc uniformLocation,
-            int value) {
+                                 ShaderProgramId shaderProgramId,
+                                 ShaderAttrLoc uniformLocation,
+                                 int value) {
         if (VERBOSE) System.err.println("JoglPipeline.setGLSLUniform1i()");
-		GL2 gl = context(ctx).getGL().getGL2();
-		gl.glUniform1iARB(unbox(uniformLocation), value);
+        GL2 gl = context(ctx).getGL().getGL2();
+        gl.glUniform1iARB(unbox(uniformLocation), value);
         return null;
     }
 
+
+    // ---------------------------------------------------------------------
+
+    //
+    // PointAttributesRetained methods
+    //
+
     @Override
     ShaderError setGLSLUniform1f(Context ctx,
-            ShaderProgramId shaderProgramId,
-            ShaderAttrLoc uniformLocation,
-            float value) {
+                                 ShaderProgramId shaderProgramId,
+                                 ShaderAttrLoc uniformLocation,
+                                 float value) {
         if (VERBOSE) System.err.println("JoglPipeline.setGLSLUniform1f()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
-		gl.glUniform1fARB(unbox(uniformLocation), value);
+        GL2 gl = context(ctx).getGL().getGL2();
+        gl.glUniform1fARB(unbox(uniformLocation), value);
         return null;
     }
 
+
+    // ---------------------------------------------------------------------
+
+    //
+    // PolygonAttributesRetained methods
+    //
+
     @Override
     ShaderError setGLSLUniform2i(Context ctx,
-            ShaderProgramId shaderProgramId,
-            ShaderAttrLoc uniformLocation,
-            int[] value) {
+                                 ShaderProgramId shaderProgramId,
+                                 ShaderAttrLoc uniformLocation,
+                                 int[] value) {
         if (VERBOSE) System.err.println("JoglPipeline.setGLSLUniform2i()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
-		gl.glUniform2iARB(unbox(uniformLocation), value[0], value[1]);
+        GL2 gl = context(ctx).getGL().getGL2();
+        gl.glUniform2iARB(unbox(uniformLocation), value[0], value[1]);
         return null;
     }
 
+
+    // ---------------------------------------------------------------------
+
+    //
+    // RenderingAttributesRetained methods
+    //
+
     @Override
     ShaderError setGLSLUniform2f(Context ctx,
-            ShaderProgramId shaderProgramId,
-            ShaderAttrLoc uniformLocation,
-            float[] value) {
+                                 ShaderProgramId shaderProgramId,
+                                 ShaderAttrLoc uniformLocation,
+                                 float[] value) {
         if (VERBOSE) System.err.println("JoglPipeline.setGLSLUniform2f()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
-		gl.glUniform2fARB(unbox(uniformLocation), value[0], value[1]);
+        GL2 gl = context(ctx).getGL().getGL2();
+        gl.glUniform2fARB(unbox(uniformLocation), value[0], value[1]);
         return null;
     }
 
     @Override
     ShaderError setGLSLUniform3i(Context ctx,
-            ShaderProgramId shaderProgramId,
-            ShaderAttrLoc uniformLocation,
-            int[] value) {
+                                 ShaderProgramId shaderProgramId,
+                                 ShaderAttrLoc uniformLocation,
+                                 int[] value) {
         if (VERBOSE) System.err.println("JoglPipeline.setGLSLUniform3i()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
-		gl.glUniform3iARB(unbox(uniformLocation), value[0], value[1], value[2]);
+        GL2 gl = context(ctx).getGL().getGL2();
+        gl.glUniform3iARB(unbox(uniformLocation), value[0], value[1], value[2]);
         return null;
     }
 
     @Override
     ShaderError setGLSLUniform3f(Context ctx,
-            ShaderProgramId shaderProgramId,
-            ShaderAttrLoc uniformLocation,
-            float[] value) {
+                                 ShaderProgramId shaderProgramId,
+                                 ShaderAttrLoc uniformLocation,
+                                 float[] value) {
         if (VERBOSE) System.err.println("JoglPipeline.setGLSLUniform3f()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
-		gl.glUniform3fARB(unbox(uniformLocation), value[0], value[1], value[2]);
+        GL2 gl = context(ctx).getGL().getGL2();
+        gl.glUniform3fARB(unbox(uniformLocation), value[0], value[1], value[2]);
         return null;
     }
 
+
+    // ---------------------------------------------------------------------
+
+    //
+    // TexCoordGenerationRetained methods
+    //
+
     @Override
     ShaderError setGLSLUniform4i(Context ctx,
-            ShaderProgramId shaderProgramId,
-            ShaderAttrLoc uniformLocation,
-            int[] value) {
+                                 ShaderProgramId shaderProgramId,
+                                 ShaderAttrLoc uniformLocation,
+                                 int[] value) {
         if (VERBOSE) System.err.println("JoglPipeline.setGLSLUniform4i()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
-		gl.glUniform4iARB(unbox(uniformLocation), value[0], value[1], value[2], value[3]);
+        GL2 gl = context(ctx).getGL().getGL2();
+        gl.glUniform4iARB(unbox(uniformLocation), value[0], value[1], value[2], value[3]);
         return null;
     }
 
+
+    // ---------------------------------------------------------------------
+
+    //
+    // TransparencyAttributesRetained methods
+    //
+
     @Override
     ShaderError setGLSLUniform4f(Context ctx,
-            ShaderProgramId shaderProgramId,
-            ShaderAttrLoc uniformLocation,
-            float[] value) {
+                                 ShaderProgramId shaderProgramId,
+                                 ShaderAttrLoc uniformLocation,
+                                 float[] value) {
         if (VERBOSE) System.err.println("JoglPipeline.setGLSLUniform4f()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
-		gl.glUniform4fARB(unbox(uniformLocation), value[0], value[1], value[2], value[3]);
+        GL2 gl = context(ctx).getGL().getGL2();
+        gl.glUniform4fARB(unbox(uniformLocation), value[0], value[1], value[2], value[3]);
         return null;
     }
 
     @Override
     ShaderError setGLSLUniformMatrix3f(Context ctx,
-            ShaderProgramId shaderProgramId,
-            ShaderAttrLoc uniformLocation,
-            float[] value) {
+                                       ShaderProgramId shaderProgramId,
+                                       ShaderAttrLoc uniformLocation,
+                                       float[] value) {
         if (VERBOSE) System.err.println("JoglPipeline.setGLSLUniformMatrix3f()");
 
         // Load attribute
         // transpose is true : each matrix is supplied in row major order
-		GL2 gl = context(ctx).getGL().getGL2();
-		gl.glUniformMatrix3fvARB(unbox(uniformLocation), 1, true, value, 0);
+        GL2 gl = context(ctx).getGL().getGL2();
+        gl.glUniformMatrix3fvARB(unbox(uniformLocation), 1, true, value, 0);
         return null;
     }
 
     @Override
     ShaderError setGLSLUniformMatrix4f(Context ctx,
-            ShaderProgramId shaderProgramId,
-            ShaderAttrLoc uniformLocation,
-            float[] value) {
+                                       ShaderProgramId shaderProgramId,
+                                       ShaderAttrLoc uniformLocation,
+                                       float[] value) {
         if (VERBOSE) System.err.println("JoglPipeline.setGLSLUniformMatrix4f()");
 
         // Load attribute
         // transpose is true : each matrix is supplied in row major order
-		GL2 gl = context(ctx).getGL().getGL2();
-		gl.glUniformMatrix4fvARB(unbox(uniformLocation), 1, true, value, 0);
+        GL2 gl = context(ctx).getGL().getGL2();
+        gl.glUniformMatrix4fvARB(unbox(uniformLocation), 1, true, value, 0);
         return null;
     }
 
-    // ShaderAttributeArray methods
-
     @Override
     ShaderError setGLSLUniform1iArray(Context ctx,
-            ShaderProgramId shaderProgramId,
-            ShaderAttrLoc uniformLocation,
-            int numElements,
-            int[] value) {
+                                      ShaderProgramId shaderProgramId,
+                                      ShaderAttrLoc uniformLocation,
+                                      int numElements,
+                                      int[] value) {
         if (VERBOSE) System.err.println("JoglPipeline.setGLSLUniform1iArray()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
-		gl.glUniform1ivARB(unbox(uniformLocation), numElements, value, 0);
+        GL2 gl = context(ctx).getGL().getGL2();
+        gl.glUniform1ivARB(unbox(uniformLocation), numElements, value, 0);
         return null;
     }
 
     @Override
     ShaderError setGLSLUniform1fArray(Context ctx,
-            ShaderProgramId shaderProgramId,
-            ShaderAttrLoc uniformLocation,
-            int numElements,
-            float[] value) {
+                                      ShaderProgramId shaderProgramId,
+                                      ShaderAttrLoc uniformLocation,
+                                      int numElements,
+                                      float[] value) {
         if (VERBOSE) System.err.println("JoglPipeline.setGLSLUniform1fArray()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
-		gl.glUniform1fvARB(unbox(uniformLocation), numElements, value, 0);
+        GL2 gl = context(ctx).getGL().getGL2();
+        gl.glUniform1fvARB(unbox(uniformLocation), numElements, value, 0);
         return null;
     }
 
     @Override
     ShaderError setGLSLUniform2iArray(Context ctx,
-            ShaderProgramId shaderProgramId,
-            ShaderAttrLoc uniformLocation,
-            int numElements,
-            int[] value) {
+                                      ShaderProgramId shaderProgramId,
+                                      ShaderAttrLoc uniformLocation,
+                                      int numElements,
+                                      int[] value) {
         if (VERBOSE) System.err.println("JoglPipeline.setGLSLUniform2iArray()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
-		gl.glUniform2ivARB(unbox(uniformLocation), numElements, value, 0);
+        GL2 gl = context(ctx).getGL().getGL2();
+        gl.glUniform2ivARB(unbox(uniformLocation), numElements, value, 0);
         return null;
     }
 
+
+    // ---------------------------------------------------------------------
+
+    //
+    // TextureAttributesRetained methods
+    //
+
     @Override
     ShaderError setGLSLUniform2fArray(Context ctx,
-            ShaderProgramId shaderProgramId,
-            ShaderAttrLoc uniformLocation,
-            int numElements,
-            float[] value) {
+                                      ShaderProgramId shaderProgramId,
+                                      ShaderAttrLoc uniformLocation,
+                                      int numElements,
+                                      float[] value) {
         if (VERBOSE) System.err.println("JoglPipeline.setGLSLUniform2fArray()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
-		gl.glUniform2fvARB(unbox(uniformLocation), numElements, value, 0);
+        GL2 gl = context(ctx).getGL().getGL2();
+        gl.glUniform2fvARB(unbox(uniformLocation), numElements, value, 0);
         return null;
     }
 
     @Override
     ShaderError setGLSLUniform3iArray(Context ctx,
-            ShaderProgramId shaderProgramId,
-            ShaderAttrLoc uniformLocation,
-            int numElements,
-            int[] value) {
+                                      ShaderProgramId shaderProgramId,
+                                      ShaderAttrLoc uniformLocation,
+                                      int numElements,
+                                      int[] value) {
         if (VERBOSE) System.err.println("JoglPipeline.setGLSLUniform3iArray()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
-		gl.glUniform3ivARB(unbox(uniformLocation), numElements, value, 0);
+        GL2 gl = context(ctx).getGL().getGL2();
+        gl.glUniform3ivARB(unbox(uniformLocation), numElements, value, 0);
         return null;
     }
 
     @Override
     ShaderError setGLSLUniform3fArray(Context ctx,
-            ShaderProgramId shaderProgramId,
-            ShaderAttrLoc uniformLocation,
-            int numElements,
-            float[] value) {
+                                      ShaderProgramId shaderProgramId,
+                                      ShaderAttrLoc uniformLocation,
+                                      int numElements,
+                                      float[] value) {
         if (VERBOSE) System.err.println("JoglPipeline.setGLSLUniform3fArray()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
-		gl.glUniform3fvARB(unbox(uniformLocation), numElements, value, 0);
+        GL2 gl = context(ctx).getGL().getGL2();
+        gl.glUniform3fvARB(unbox(uniformLocation), numElements, value, 0);
         return null;
     }
 
     @Override
     ShaderError setGLSLUniform4iArray(Context ctx,
-            ShaderProgramId shaderProgramId,
-            ShaderAttrLoc uniformLocation,
-            int numElements,
-            int[] value) {
+                                      ShaderProgramId shaderProgramId,
+                                      ShaderAttrLoc uniformLocation,
+                                      int numElements,
+                                      int[] value) {
         if (VERBOSE) System.err.println("JoglPipeline.setGLSLUniform4iArray()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
-		gl.glUniform4ivARB(unbox(uniformLocation), numElements, value, 0);
+        GL2 gl = context(ctx).getGL().getGL2();
+        gl.glUniform4ivARB(unbox(uniformLocation), numElements, value, 0);
         return null;
     }
 
+    // Helper routines for above
+
     @Override
     ShaderError setGLSLUniform4fArray(Context ctx,
-            ShaderProgramId shaderProgramId,
-            ShaderAttrLoc uniformLocation,
-            int numElements,
-            float[] value) {
+                                      ShaderProgramId shaderProgramId,
+                                      ShaderAttrLoc uniformLocation,
+                                      int numElements,
+                                      float[] value) {
         if (VERBOSE) System.err.println("JoglPipeline.setGLSLUniform4fArray()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
-		gl.glUniform4fvARB(unbox(uniformLocation), numElements, value, 0);
+        GL2 gl = context(ctx).getGL().getGL2();
+        gl.glUniform4fvARB(unbox(uniformLocation), numElements, value, 0);
         return null;
     }
 
     @Override
     ShaderError setGLSLUniformMatrix3fArray(Context ctx,
-            ShaderProgramId shaderProgramId,
-            ShaderAttrLoc uniformLocation,
-            int numElements,
-            float[] value) {
+                                            ShaderProgramId shaderProgramId,
+                                            ShaderAttrLoc uniformLocation,
+                                            int numElements,
+                                            float[] value) {
         if (VERBOSE) System.err.println("JoglPipeline.setGLSLUniformMatrix3fArray()");
 
         // Load attribute
         // transpose is true : each matrix is supplied in row major order
-		GL2 gl = context(ctx).getGL().getGL2();
-		gl.glUniformMatrix3fvARB(unbox(uniformLocation), numElements, true, value, 0);
+        GL2 gl = context(ctx).getGL().getGL2();
+        gl.glUniformMatrix3fvARB(unbox(uniformLocation), numElements, true, value, 0);
         return null;
     }
 
     @Override
     ShaderError setGLSLUniformMatrix4fArray(Context ctx,
-            ShaderProgramId shaderProgramId,
-            ShaderAttrLoc uniformLocation,
-            int numElements,
-            float[] value) {
+                                            ShaderProgramId shaderProgramId,
+                                            ShaderAttrLoc uniformLocation,
+                                            int numElements,
+                                            float[] value) {
         if (VERBOSE) System.err.println("JoglPipeline.setGLSLUniformMatrix4fArray()");
 
         // Load attribute
         // transpose is true : each matrix is supplied in row major order
-		GL2 gl = context(ctx).getGL().getGL2();
-		gl.glUniformMatrix4fvARB(unbox(uniformLocation), numElements, true, value, 0);
+        GL2 gl = context(ctx).getGL().getGL2();
+        gl.glUniformMatrix4fvARB(unbox(uniformLocation), numElements, true, value, 0);
         return null;
     }
 
@@ -3081,7 +3689,7 @@
     ShaderError createGLSLShader(Context ctx, int shaderType, ShaderId[] shaderId) {
         if (VERBOSE) System.err.println("JoglPipeline.createGLSLShader()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
 
         int shaderHandle = 0;
         if (shaderType == Shader.SHADER_TYPE_VERTEX) {
@@ -3098,14 +3706,16 @@
         shaderId[0] = new JoglShaderObject(shaderHandle);
         return null;
     }
+
     @Override
     ShaderError destroyGLSLShader(Context ctx, ShaderId shaderId) {
         if (VERBOSE) System.err.println("JoglPipeline.destroyGLSLShader()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
         gl.glDeleteObjectARB(unbox(shaderId));
         return null;
     }
+
     @Override
     ShaderError compileGLSLShader(Context ctx, ShaderId shaderId, String program) {
         if (VERBOSE) System.err.println("JoglPipeline.compileGLSLShader()");
@@ -3119,8 +3729,8 @@
             throw new AssertionError("shader program string is null");
         }
 
-		GL2 gl = context(ctx).getGL().getGL2();
-        gl.glShaderSourceARB(id, 1, new String[] { program }, null, 0);
+        GL2 gl = context(ctx).getGL().getGL2();
+        gl.glShaderSourceARB(id, 1, new String[]{program}, null, 0);
         gl.glCompileShaderARB(id);
         int[] status = new int[1];
         gl.glGetObjectParameterivARB(id, GL2.GL_OBJECT_COMPILE_STATUS_ARB, status, 0);
@@ -3138,7 +3748,7 @@
     ShaderError createGLSLShaderProgram(Context ctx, ShaderProgramId[] shaderProgramId) {
         if (VERBOSE) System.err.println("JoglPipeline.createGLSLShaderProgram()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
 
         int shaderProgramHandle = (int) gl.glCreateProgramObjectARB();
         if (shaderProgramHandle == 0) {
@@ -3148,19 +3758,62 @@
         shaderProgramId[0] = new JoglShaderObject(shaderProgramHandle);
         return null;
     }
+
+// FIXME: GL_NV_register_combiners
+//    private int getCombinerArg(GL gl, int arg, int textureUnit, int combUnit) {
+//        int comb = 0;
+//
+//        switch (arg) {
+//            case TextureAttributes.COMBINE_OBJECT_COLOR:
+//                if (combUnit == GL.GL_COMBINER0_NV) {
+//                    comb = GL.GL_PRIMARY_COLOR_NV;
+//                } else {
+//                    comb = GL.GL_SPARE0_NV;
+//                }
+//                break;
+//            case TextureAttributes.COMBINE_TEXTURE_COLOR:
+//                comb = textureUnit;
+//                break;
+//            case TextureAttributes.COMBINE_CONSTANT_COLOR:
+//                comb = GL.GL_CONSTANT_COLOR0_NV;
+//                break;
+//            case TextureAttributes.COMBINE_PREVIOUS_TEXTURE_UNIT_STATE:
+//                comb = textureUnit -1;
+//                break;
+//        }
+//
+//        return comb;
+//    }
+
+
+    // ---------------------------------------------------------------------
+
+    //
+    // TextureUnitStateRetained methods
+    //
+
     @Override
     ShaderError destroyGLSLShaderProgram(Context ctx, ShaderProgramId shaderProgramId) {
         if (VERBOSE) System.err.println("JoglPipeline.destroyGLSLShaderProgram()");
-		GL2 gl = context(ctx).getGL().getGL2();
-		gl.glDeleteObjectARB(unbox(shaderProgramId));
+        GL2 gl = context(ctx).getGL().getGL2();
+        gl.glDeleteObjectARB(unbox(shaderProgramId));
         return null;
     }
+
+
+    // ---------------------------------------------------------------------
+
+    //
+    // TextureRetained methods
+    // Texture2DRetained methods
+    //
+
     @Override
     ShaderError linkGLSLShaderProgram(Context ctx, ShaderProgramId shaderProgramId,
-            ShaderId[] shaderIds) {
+                                      ShaderId[] shaderIds) {
         if (VERBOSE) System.err.println("JoglPipeline.linkGLSLShaderProgram()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
         int id = unbox(shaderProgramId);
         for (int i = 0; i < shaderIds.length; i++) {
             gl.glAttachObjectARB(id, unbox(shaderIds[i]));
@@ -3177,21 +3830,23 @@
         }
         return null;
     }
+
     @Override
     ShaderError bindGLSLVertexAttrName(Context ctx, ShaderProgramId shaderProgramId,
-            String attrName, int attrIndex) {
+                                       String attrName, int attrIndex) {
         if (VERBOSE) System.err.println("JoglPipeline.bindGLSLVertexAttrName()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
-		gl.glBindAttribLocation(unbox(shaderProgramId),
+        GL2 gl = context(ctx).getGL().getGL2();
+        gl.glBindAttribLocation(unbox(shaderProgramId),
                 attrIndex + VirtualUniverse.mc.glslVertexAttrOffset,
                 attrName);
         return null;
     }
+
     @Override
     void lookupGLSLShaderAttrNames(Context ctx, ShaderProgramId shaderProgramId,
-            int numAttrNames, String[] attrNames, ShaderAttrLoc[] locArr,
-            int[] typeArr, int[] sizeArr, boolean[] isArrayArr) {
+                                   int numAttrNames, String[] attrNames, ShaderAttrLoc[] locArr,
+                                   int[] typeArr, int[] sizeArr, boolean[] isArrayArr) {
         if (VERBOSE) System.err.println("JoglPipeline.lookupGLSLShaderAttrNames()");
 
         // set the loc, type, and size arrays to out-of-bound values
@@ -3214,7 +3869,7 @@
         int[] tmp = new int[1];
         int[] tmp2 = new int[1];
         int[] tmp3 = new int[1];
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
         gl.glGetObjectParameterivARB(id,
                 GL2.GL_OBJECT_ACTIVE_UNIFORMS_ARB,
                 tmp, 0);
@@ -3274,8 +3929,8 @@
     ShaderError useGLSLShaderProgram(Context ctx, ShaderProgramId shaderProgramId) {
         if (VERBOSE) System.err.println("JoglPipeline.useGLSLShaderProgram()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
-		gl.glUseProgramObjectARB(unbox(shaderProgramId));
+        GL2 gl = context(ctx).getGL().getGL2();
+        gl.glUseProgramObjectARB(unbox(shaderProgramId));
         ((JoglContext) ctx).setShaderProgram((JoglShaderObject) shaderProgramId);
         return null;
     }
@@ -3351,7 +4006,7 @@
             case GL2.GL_FLOAT_VEC4_ARB:
                 return ShaderAttributeObjectRetained.TYPE_TUPLE4F;
 
-                // case GL.GL_FLOAT_MAT2_ARB:
+            // case GL.GL_FLOAT_MAT2_ARB:
 
             case GL2.GL_FLOAT_MAT3_ARB:
                 return ShaderAttributeObjectRetained.TYPE_MATRIX3F;
@@ -3359,41 +4014,39 @@
             case GL2.GL_FLOAT_MAT4_ARB:
                 return ShaderAttributeObjectRetained.TYPE_MATRIX4F;
 
-                // Java 3D does not support the following sampler types:
-                //
-                // case GL.GL_SAMPLER_1D_ARB:
-                // case GL.GL_SAMPLER_1D_SHADOW_ARB:
-                // case GL.GL_SAMPLER_2D_SHADOW_ARB:
-                // case GL.GL_SAMPLER_2D_RECT_ARB:
-                // case GL.GL_SAMPLER_2D_RECT_SHADOW_ARB:
+            // Java 3D does not support the following sampler types:
+            //
+            // case GL.GL_SAMPLER_1D_ARB:
+            // case GL.GL_SAMPLER_1D_SHADOW_ARB:
+            // case GL.GL_SAMPLER_2D_SHADOW_ARB:
+            // case GL.GL_SAMPLER_2D_RECT_ARB:
+            // case GL.GL_SAMPLER_2D_RECT_SHADOW_ARB:
         }
 
         return -1;
     }
 
-    // ---------------------------------------------------------------------
-
-    //
-    // ColoringAttributesRetained methods
-    //
-
     @Override
     void updateColoringAttributes(Context ctx,
-            float dRed, float dGreen, float dBlue,
-            float red, float green, float blue,
-            float alpha,
-            boolean lightEnable,
-            int shadeModel) {
+                                  float dRed, float dGreen, float dBlue,
+                                  float red, float green, float blue,
+                                  float alpha,
+                                  boolean lightEnable,
+                                  int shadeModel) {
         if (VERBOSE) System.err.println("JoglPipeline.updateColoringAttributes()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
 
         float cr, cg, cb;
 
         if (lightEnable) {
-            cr = dRed; cg = dGreen; cb = dBlue;
-        } else {
-            cr = red; cg = green; cb = blue;
+            cr = dRed;
+            cg = dGreen;
+            cb = dBlue;
+        } else {
+            cr = red;
+            cg = green;
+            cb = blue;
         }
         gl.glColor4f(cr, cg, cb, alpha);
         if (shadeModel == ColoringAttributes.SHADE_FLAT) {
@@ -3403,21 +4056,13 @@
         }
     }
 
-
-    // ---------------------------------------------------------------------
-
-    //
-    // DirectionalLightRetained methods
-    //
-
-    private static final float[] black = new float[4];
     @Override
     void updateDirectionalLight(Context ctx,
-            int lightSlot, float red, float green,
-            float blue, float dirx, float diry, float dirz) {
+                                int lightSlot, float red, float green,
+                                float blue, float dirx, float diry, float dirz) {
         if (VERBOSE) System.err.println("JoglPipeline.updateDirectionalLight()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
 
         int lightNum = GL2.GL_LIGHT0 + lightSlot;
         float[] values = new float[4];
@@ -3441,21 +4086,14 @@
         gl.glLightf(lightNum, GL2.GL_SPOT_CUTOFF, 180.0f);
     }
 
-
-    // ---------------------------------------------------------------------
-
-    //
-    // PointLightRetained methods
-    //
-
     @Override
     void updatePointLight(Context ctx,
-            int lightSlot, float red, float green,
-            float blue, float attenx, float atteny, float attenz,
-            float posx, float posy, float posz) {
+                          int lightSlot, float red, float green,
+                          float blue, float attenx, float atteny, float attenz,
+                          float posx, float posy, float posz) {
         if (VERBOSE) System.err.println("JoglPipeline.updatePointLight()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
 
         int lightNum = GL2.GL_LIGHT0 + lightSlot;
         float[] values = new float[4];
@@ -3478,23 +4116,16 @@
         gl.glLightf(lightNum, GL2.GL_SPOT_CUTOFF, 180.0f);
     }
 
-
-    // ---------------------------------------------------------------------
-
-    //
-    // SpotLightRetained methods
-    //
-
     @Override
     void updateSpotLight(Context ctx,
-            int lightSlot, float red, float green,
-            float blue, float attenx, float atteny, float attenz,
-            float posx, float posy, float posz, float spreadAngle,
-            float concentration, float dirx, float diry,
-            float dirz) {
+                         int lightSlot, float red, float green,
+                         float blue, float attenx, float atteny, float attenz,
+                         float posx, float posy, float posz, float spreadAngle,
+                         float concentration, float dirx, float diry,
+                         float dirz) {
         if (VERBOSE) System.err.println("JoglPipeline.updateSpotLight()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
 
         int lightNum = GL2.GL_LIGHT0 + lightSlot;
         float[] values = new float[4];
@@ -3521,20 +4152,19 @@
         gl.glLightf(lightNum, GL2.GL_SPOT_CUTOFF, (float) (spreadAngle * 180.0f / Math.PI));
     }
 
-
     // ---------------------------------------------------------------------
 
     //
-    // ExponentialFogRetained methods
+    // Texture3DRetained methods
     //
 
     @Override
     void updateExponentialFog(Context ctx,
-            float red, float green, float blue,
-            float density) {
+                              float red, float green, float blue,
+                              float density) {
         if (VERBOSE) System.err.println("JoglPipeline.updateExponentialFog()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
 
         float[] color = new float[3];
         color[0] = red;
@@ -3546,20 +4176,13 @@
         gl.glEnable(GL2.GL_FOG);
     }
 
-
-    // ---------------------------------------------------------------------
-
-    //
-    // LinearFogRetained methods
-    //
-
     @Override
     void updateLinearFog(Context ctx,
-            float red, float green, float blue,
-            double fdist, double bdist) {
+                         float red, float green, float blue,
+                         double fdist, double bdist) {
         if (VERBOSE) System.err.println("JoglPipeline.updateLinearFog()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
 
         float[] color = new float[3];
         color[0] = red;
@@ -3572,22 +4195,15 @@
         gl.glEnable(GL2.GL_FOG);
     }
 
-
-    // ---------------------------------------------------------------------
-
-    //
-    // LineAttributesRetained methods
-    //
-
     @Override
     void updateLineAttributes(Context ctx,
-            float lineWidth, int linePattern,
-            int linePatternMask,
-            int linePatternScaleFactor,
-            boolean lineAntialiasing) {
+                              float lineWidth, int linePattern,
+                              int linePatternMask,
+                              int linePatternScaleFactor,
+                              boolean lineAntialiasing) {
         if (VERBOSE) System.err.println("JoglPipeline.updateLineAttributes()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
         gl.glLineWidth(lineWidth);
 
         if (linePattern == LineAttributes.PATTERN_SOLID) {
